/**********************************************************************
  t@C̊gqoAtH[}bg^CvԂ
  $Id: get_ftype.c,v 1.6 1998/10/31 08:51:15 TANE Exp $
**********************************************************************/

#include	"common.h"
#include	"filetype.h"
#include	"funcs.h"

int	get_ftype( char *file_str )
{
struct	EXT_LIST_STRUCT{
	char	*ext_name ;
	int		type ;
} ;
static struct EXT_LIST_STRUCT ext_tbl[] = {
	{ ".suf" , SUF_FILE } ,
	{ ".atr" , ATR_FILE } ,
	{ ".fsc" , FSC_FILE } ,
	{ NULL   , UNKNOWN_FILE_TYPE }
} ;
char	*workpt ;
short	flag ;
short	gz_flag ;
unsigned char	ext_tmp[16] ;
int		i ;

	flag    = 0 ;
	gz_flag = 0 ;

	if( *file_str == '\0' ||
	    *file_str == '\n' || *file_str == '\r' ) flag = FILE_IS_NULL ;
	else{
		workpt = file_str ;
		while( -1 ){
			if( *workpt == '\0' ||
			    *workpt == '\n' || *workpt == '\r' ) break ;
			workpt++ ;
		}
		if( strcmpi( (workpt-3), GZ_SUFFIX )==0 ){
			gz_flag=1 ;
			workpt -= 4 ;
		}
		while( -1 ){
			if( workpt == file_str ){
				flag = NOT_FOUND_PERIODO ;
				break ;
			}
			if( *workpt == '.' ) break ;
			workpt-- ;
		}
	}

	if( flag == 0 ){
		for( i=0 ; ; i++ ){
			strcpy( ext_tmp , ext_tbl[i].ext_name ) ;
			if( gz_flag == 1 ) strcat( ext_tmp , GZ_SUFFIX ) ;
			if( ext_tbl[i].ext_name==NULL ||
			    strcmpi(workpt, ext_tmp)==0 ){
				if( gz_flag == 1 ){
					return( ext_tbl[i].type|GZIPED_FILE ) ;
				}else{
			    	return( ext_tbl[i].type ) ;
			    }
			}
		}
	}
	return( flag ) ;
}
