/**********************************************************************
  Read .ATR
  $Id:$
**********************************************************************/
#include	"common.h"
#include	"funcs.h"
#include	"suf2pov.h"

int	read_atr( unsigned char *fname, struct ATR_STRUCT *atr_pt, int atr_num )
{
unsigned char	str_line[TOKEN_STR_LEN] ;
FILE	*ifp ;

int	getting_atr ;

	token_pt = &token ;

	if( (ifp=fopen( fname , "rb" )) == NULL ){
		fprintf(stderr,"t@C %s I[vł܂\n",fname) ;
		return(FILE_OPEN_ERROR) ;
	}

	getting_atr=NO ;
	while( -1 ){
		if( fgets( str_line , TOKEN_STR_LEN , ifp )==NULL ) break ;
		if( feof(ifp)!=0 ) break ;
		if( get_token( str_line , token_pt )==0 ) continue ;

		if( strcmp(token_pt->pt[0],"atr")==0 ){
			strcpy(atr_pt[atr_num].name,token_pt->pt[1]) ;
			getting_atr=YES ;
			continue ;
		}
		if( getting_atr==YES ){
			if( strcmp(token_pt->pt[0],"col")==0 ){
				if( strcmp(token_pt->pt[2],"rgb")==0 ){
					atr_pt[atr_num].r= atof(token_pt->pt[4]) ;
					atr_pt[atr_num].g= atof(token_pt->pt[5]) ;
					atr_pt[atr_num].b= atof(token_pt->pt[6]) ;
				}else{
					atr_pt[atr_num].r= atof(token_pt->pt[2]) ;
					atr_pt[atr_num].g= atof(token_pt->pt[2]) ;
					atr_pt[atr_num].b= atof(token_pt->pt[2]) ;
				}
				continue ;
			}
			if( strcmp(token_pt->pt[0],"tra")==0 ){
				atr_pt[atr_num].tra= atof(token_pt->pt[2]) ;
				continue ;
			}
			if( strcmp(token_pt->pt[0],"amb")==0 ){
				atr_pt[atr_num].amb= atof(token_pt->pt[2]) ;
				continue ;
			}
			if( strcmp(token_pt->pt[0],"dif")==0 ){
				atr_pt[atr_num].dif= atof(token_pt->pt[2]) ;
				continue ;
			}
			if( strcmp(token_pt->pt[0],"spc")==0 ){
				atr_pt[atr_num].spc_pow = atof(token_pt->pt[2]) ;
				atr_pt[atr_num].spc_bril= atof(token_pt->pt[3]) ;
				continue ;
			}
			if( strcmp(token_pt->pt[0],"ref")==0 ){
				atr_pt[atr_num].ref= atof(token_pt->pt[2]) ;
				continue ;
			}
			if( strcmp(token_pt->pt[0],"}")==0 ){
				atr_num++ ;
				if( atr_num >= ATR_MAX ){
					fprintf(stderr,"Agr[gVXeő吔ɒB܂\n") ;
					break ;
				}
				getting_atr=NO ;
			}
		}
	}

	fclose( ifp ) ;

	return( atr_num ) ;
}

